divert(-1)
#
# J.Rafa 2006
# check if local sender is valid
# based partially on check_* rulesets for Sendmail 8.8.x by Claus Assmann
#
# change history:
# v1.2, 2006-09-30, first published version
# v1.3, 2006-10-10, fixed rejection of empty sender (MAIL FROM:<>) when
#    virtusertable is not used
#
define(`_LOCAL_SENDER_CHECK_',`')
divert(0)
VERSIONID(`@(#) local_sender_check.m4, v 1.3, 2006-10-10 J.Rafa')dnl
divert(6)
# Maps to look up user names in local_check
Kpasswd user -m -a@LOCALUSER
Kalias implicit -m -a@LOCALUSER ALIAS_FILE
Klocal sequence alias passwd
divert(0)dnl
LOCAL_RULESETS
# determine whether a local address exists or not.
Slocal_check
R$+			$: <?> $1
R<?> $+ + $*		$: $(local $1 $)
R<?> $+			$: $(local $1 $)
# something wrong?
R<?> $+			$: OOPS $1		cannot happen...
R$+@LOCALUSER		$@ OK
ifdef(`_DELAY_CHECKS_',
`R$+			$#error $@ 5.1.1 $: 550 Sender user $&f unknown',
`R$+			$#error $@ 5.1.1 $: 550 User unknown')
ifdef(`_VIRTUSER_TABLE_',`
# Check if address exists in virtusertable
Svirtuser_check
# First check user@domain (and save original address at the end).
R<$+ @ $+>		$: <$(virtuser $1 @ $2 $@ $1 $: @ $)><$1@$2>
# Check username+*@domain for plussed users.
R<@><$+ + $* @ $*>	$: <$(virtuser $1 + * @ $3 $@ $1 $: @ $)><$1+$2@$3>
# Check username@domain for plussed users.
R<@><$+ + $* @ $*>	$: <$(virtuser $1 @ $3 $@ $1 $: @ $)><$1+$2@$3>
# Check @domain.
R<@><$+ @ $*>		$: <$(virtuser @ $2 $@ $1 $: @ $)><$1@$2>
# If <@> remains, no match was done.
R<@> $*			$@ $1
# User found in virtusertable. 
R<error:$-.$-.$-:$+> <$*> 	$#error $@ $1.$2.$3 $: $4
R<error:$- $+> <$*> 	$#error $@ $(dequote $1 $) $: $2
ifdef(`_NO_VIRTUSER_RECURSION_',`dnl',
`R<$*@$*> <$*>		$@ $>virtuser_check <$1@$2>')
R<$*> <$*>		$@ $1',`dnl')

# if sender address is local, check if it exists
Slocal_user_check
# accept empty sender
R<>			$@ OK
ifdef(`RAJ_HACKED_PROTOM4',
`# skip canonicalization if marked by <OK>
R$+			$: <?> $1
R<?> <OK> $+ . >	$: $1 . >
R<?> <OK> $+ >		$: $1 . >		add dot if stripped
R<?> <OK> $+		$: $1
R<?> $+			$: $>CanonAddr $1',
`R$+			$: $>CanonAddr $1')
ifdef(`_VIRTUSER_TABLE_',`# handle virtual users
ifdef(`_VIRTUSER_ENTIRE_DOMAIN_',
`R $+ <@$* $={VirtHost} .>	$: <@> $>virtuser_check <$1@$2$3>',
`R $+ <@$={VirtHost} .>	$: <@> $>virtuser_check <$1@$2>')
# if a non-local address was found in virtusertable, canonify again
R <@> $* @ $*		$: $>CanonAddr $1@$2
R <@> $*		$: $1',`dnl')
R $+ <@$=w .>		$@ $>local_check $1
R $+ <@$*>		$@ $1 <@ $2>
R $+			$@ $>local_check $1
ifdef(`RAJ_HACKED_PROTOM4',`dnl',
`
SLocal_check_mail
R$*			$@ $>local_user_check $1')
