divert(-1)
#
# J.Rafa 2006
# this feature changes the check order when delay_checks is used;
# by default, when delay_checks is defined, sendmail calls first check_rcpt,
# then check_mail and finally check_relay. However, when check_mail
# finds a sender address whitelisted in access db (marked 'OK' or 'RELAY'),
# it accepts the mail and doesn't call check_relay.
# This makes no sense since it's hard to trust a sender address of an e-mail
# sent from an incidental host; this can be easily faked, so it is advisable
# to call check_relay regardless of the results of check_mail.
# Also, by default delay_checks skips both check_mail and check_relay
# for successfully authenticated (either via TLS or via SMTP AUTH) clients.
# This allows these clients to send e-mail with invalid sender addresses
# (eg. from unresolvable domains, or from nonexistent local senders when
# local_sender_check is also used). This shouldn't happen, so this feature
# puts the check_mail first, then check_rcpt and finally check_relay (the
# latter is skipped for authenticated clients). However, the 'spam friend'
# or 'spam hater' options to delay_checks make an exception - if user is
# marked as 'spam friend' or 'non-spam hater' in the access map, check_mail
# is skipped for these users entirely.
# You can also use this feature together with feature 'skip_checkmail_if_auth'.
# This turns off checkmail for authenticated clients, restoring *almost* the
# standard behaviour of delay_checks with the exception that for
# non-authenticated clients check_relay will be run as well as check_mail.
#
ifdef(`RAJ_HACKED_PROTOM4',`define(`_NATURAL_CHECK_ORDER_',`')',
`ifdef(`_DELAY_CHECKS_',
`ifdef(`_RELAY_MAYBE_',
`errprint(`*** FEATURE(relay_maybe) must be defined after FEATURE(natural_check_order)
')',
`define(`_NATURAL_CHECK_ORDER_',`')'
)',
`errprint(`*** FEATURE(natural_check_order) requires FEATURE(delay_checks) defined before
')'
)'
)

ifdef(`_NATURAL_CHECK_ORDER_',
`divert(0)
VERSIONID(`@(#) natural_check_order.m4, v 2.3, 2006-09-30 J.Rafa')dnl
ifdef(`RAJ_HACKED_PROTOM4',`divert(-1)',`divert(9)
')
ifdef(`_SPAM_FH_',
`Sspam_lookup
dnl code copied from proto.m4
R$*			$: <?> $>FullAddr $>CanonAddr $1
R<?> $+ < @ $=w >	$: <> $1 < @ $2 > $| <F: $1@$2 > <D: $2 > <U: $1@>
R<?> $+ < @ $* >	$: <> $1 < @ $2 > $| <F: $1@$2 > <D: $2 >
dnl R<?>		$@ something_is_very_wrong_here
# lookup the addresses only with Spam tag
R<> $* $| <$+>		$: <@> $1 $| $>SearchList <! Spam> $| <$2> <>
R<@> $* $| $*		$: $2 $1		reverse result
dnl', `dnl')
ifdef(`_SPAM_FRIEND_',
`# is the recipient a spam friend?
ifdef(`_SPAM_HATER_',
	`errprint(`*** ERROR: define either Hater or Friend -- not both.
')', `dnl')
R<FRIEND> $+		$@ $>"Delay_TLS_Clt2" SPAMFRIEND	spam friend: stop checks
R<$*> $+		$: $2			continue',
`dnl')
ifdef(`_SPAM_HATER_',
`# is the recipient no spam hater?
R<HATER> $+		$: $1			spam hater: continue checks
R<$*> $+		$@ $>"Delay_TLS_Clt2" NOSPAMHATER	everyone else: stop
dnl',`dnl')

SLocal_check_rcpt
# because we must change order of checkrcpt, checkmail and checkrelay,
# everything will be placed here
ifdef(`_SPAM_FH_',
`# is the user a spam friend/non-hater?
R$*			$: $1 $| $>spam_lookup $1
R$* $| SPAMFRIEND	$# OK
R$* $| NOSPAMHATER	$# OK
R$* $| $#$*		$#$2
# yes - return and accept mail
ifdef(`_SKIP_CHECKMAIL_IF_AUTH_',`dnl',
`ifdef(`_FFR_MAIL_MACRO',
`R$* $| $*		$: $1 $| $>checkmail $&{mail_from}',
`R$* $| $*		$: $1 $| $>checkmail <$&f>')
dnl on error (or discard) stop now
R$+ $| $#error $* "550 Access denied"	$: $1 $| $#error $2 "550 Access denied for sender " $&f
R$+ $| $#error $*	$#error $2
R$+ $| $#discard $*	$#discard $2')
R$* $| $*		$: $1 $| <@> ${RelayMaybeDefined}',
`R$*			$: $1 $| <@> ${RelayMaybeDefined}')
R$* $| <@> YES		$: $1 $| $>Actual_check_rcpt $1
R$* $| <@> $*		$: $1 $| $>Basic_check_rcpt $1
R$* $| $#$+		$#$2
# reject or client authenticated - return
ifdef(`_USE_CLIENT_PTR_',
`R$* $| $*		$: $1 $| $>checkrelay $&{client_ptr} $| $&{client_addr}',
`R$* $| $*		$: $1 $| $>checkrelay $&{client_name} $| $&{client_addr}')
dnl on error (or discard) stop now
R$* $| $#error $* "550 Access denied"	$: $1 $| $#error $2 "550 Access denied for host " $&{client_name}
R$* $| $#error $*	$#error $2
R$* $| $#discard $*	$#discard $2
ifdef(`_SKIP_CHECKMAIL_IF_AUTH_',
`ifdef(`_FFR_MAIL_MACRO',
`R$* $| $*		$: $1 $| $>checkmail $&{mail_from}',
`R$* $| $*		$: $1 $| $>checkmail <$&f>')
R$* $| $#$+		$#$2
# reject - return',`dnl')
# finally, accept the mail and disable further processing
R$* $| $*		$# OK
ifdef(`_SPAM_FH_',`',
`ifdef(`_SKIP_CHECKMAIL_IF_AUTH_',`',
`
Scheck_mail
R$*			$@ $>checkmail $1')')')
